## bddisasm 1.37.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

option(BDD_INCLUDE_TOOL "Include the disasmtool executable" ON)
option(BDD_INCLUDE_ISAGENERATOR "Include the isagenerator target (if a python interpreter is found)" ON)
option(BDD_INCLUDE_FUZZERS "Include the bdshemu fuzzer" OFF)
option(BDD_USE_EXTERNAL_VSNPRINTF "Expect nd_vsnprintf_s implementation from the integrator" OFF)
option(BDD_USE_EXTERNAL_MEMSET "Expect nd_memset implementation from the integrator" OFF)

set(BDD_VER_FILE ${CMAKE_CURRENT_LIST_DIR}/inc/version.h)

file(STRINGS ${BDD_VER_FILE} disasm_ver_major REGEX "DISASM_VERSION_MAJOR")
file(STRINGS ${BDD_VER_FILE} disasm_ver_minor REGEX "DISASM_VERSION_MINOR")
file(STRINGS ${BDD_VER_FILE} disasm_ver_patch REGEX "DISASM_VERSION_REVISION")

string(REGEX REPLACE "#define DISASM_VERSION_MAJOR[ \t\r\n]*" "" disasm_ver_major ${disasm_ver_major})
string(REGEX REPLACE "#define DISASM_VERSION_MINOR[ \t\r\n]*" "" disasm_ver_minor ${disasm_ver_minor})
string(REGEX REPLACE "#define DISASM_VERSION_REVISION[ \t\r\n]*" "" disasm_ver_patch ${disasm_ver_patch})

message(STATUS "Extracted version from ${BDD_VER_FILE}: ${disasm_ver_major}.${disasm_ver_minor}.${disasm_ver_patch}")

project(
    bddisasm
    VERSION ${disasm_ver_major}.${disasm_ver_minor}.${disasm_ver_patch}
    DESCRIPTION "Bitdefender x86 instruction decoder and emulator"
    LANGUAGES C
    HOMEPAGE_URL https://github.com/bitdefender/bddisasm)

# Use Release as the build type if no build type was specified and we're not using a multi-config generator    .
if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    message(STATUS "No build type given. Will use 'Release'")
    set(CMAKE_BUILD_TYPE
        "Release"
        CACHE STRING "Choose the type of build." FORCE)
    # Set the possible values of build type for cmake-gui.
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release")
endif ()

# These are shared by bddisasm and bdshemu.
if (MSVC OR "${CMAKE_C_COMPILER_FRONTEND_VARIANT}" STREQUAL "MSVC")
    set(BDDISASM_COMMON_COMPILE_OPTIONS /W4 /WX)
else ()
    set(BDDISASM_COMMON_COMPILE_OPTIONS
        "$<$<CONFIG:Release>:-U_FORTIFY_SOURCE>"
        "$<$<CONFIG:Release>:-D_FORTIFY_SOURCE=2>"
        -Wall
        -Wno-unknown-pragmas
        -Wextra
        -Wshadow
        -Wformat-security
        -Wstrict-overflow=2
        -Wstrict-prototypes
        -Wwrite-strings
        -Wshadow
        -Winit-self
        -Wno-unused-function
        -Wno-multichar
        -Wno-incompatible-pointer-types
        -Wnull-dereference
        -Werror=format-security
        -Werror=implicit-function-declaration
        -pipe
        -fwrapv
        -fno-strict-aliasing
        -fstack-protector-strong
        -fno-omit-frame-pointer
        -ffunction-sections
        -fdata-sections
        -g3
        -gdwarf-4
        -grecord-gcc-switches
        -march=westmere)

    if (CMAKE_C_COMPILER_ID STREQUAL "GNU")
        list(APPEND BDDISASM_COMMON_COMPILE_OPTIONS
            -Wduplicated-cond
            -Wno-discarded-qualifiers)
    endif ()
endif ()

set(BDDISASM_PUBLIC_HEADERS
    "inc/bddisasm.h"
    "inc/constants.h"
    "inc/cpuidflags.h"
    "inc/disasmstatus.h"
    "inc/disasmtypes.h"
    "inc/registers.h"
    "inc/version.h")

include(GNUInstallDirs)

set(BDDISASM_INSTALL_INCLUDE_DIR
    "${CMAKE_INSTALL_INCLUDEDIR}/bddisasm"
    CACHE STRING "Path to bddisasm public include files.")

# -- bddisasm --

include(CheckFunctionExists)
include(CheckSymbolExists)
include(CheckCCompilerFlag)

add_library(
    bddisasm STATIC
    bddisasm/crt.c
    bddisasm/bddisasm.c
    bddisasm/bdformat.c
    bddisasm/bdhelpers.c
    # Add the headers so they will show up in IDEs.
    bddisasm/include/instructions.h
    bddisasm/include/mnemonics.h
    bddisasm/include/nd_crt.h
    bddisasm/include/prefixes.h
    bddisasm/include/table_evex.h
    bddisasm/include/table_root.h
    bddisasm/include/table_vex.h
    bddisasm/include/table_xop.h
    bddisasm/include/tabledefs.h
    "${BDDISASM_PUBLIC_HEADERS}")

if (NOT BDD_USE_EXTERNAL_VSNPRINTF)
    check_function_exists(vsnprintf HAS_VSNPRINTF)
    if (HAS_VSNPRINTF)
        target_compile_definitions(bddisasm PUBLIC -DBDDISASM_HAS_VSNPRINTF)
    else ()
        # See https://cmake.org/Bug/view.php?id=15659
        check_symbol_exists(vsnprintf stdio.h HAS_VSNPRINTF_SYMBOL)
        if (HAS_VSNPRINTF_SYMBOL)
            target_compile_definitions(bddisasm PUBLIC -DBDDISASM_HAS_VSNPRINTF)
        endif ()
    endif ()
endif ()

if (NOT BDD_USE_EXTERNAL_MEMSET)
    check_function_exists(memset HAS_MEMSET)
    if (HAS_MEMSET)
        target_compile_definitions(bddisasm PUBLIC -DBDDISASM_HAS_MEMSET)
    endif ()
endif ()

set_target_properties(
    bddisasm
    PROPERTIES POSITION_INDEPENDENT_CODE ON
               C_STANDARD 11
               VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH})

target_include_directories(bddisasm PRIVATE bddisasm/include)
target_include_directories(bddisasm PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/inc>
                                           $<INSTALL_INTERFACE:${BDDISASM_INSTALL_INCLUDE_DIR}>)

target_compile_options(bddisasm PRIVATE ${BDDISASM_COMMON_COMPILE_OPTIONS})

set_target_properties(
    bddisasm
    PROPERTIES PUBLIC_HEADER "${BDDISASM_PUBLIC_HEADERS}"
               VERSION ${CMAKE_PROJECT_VERSION}
               SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR})

add_library(bddisasm::bddisasm ALIAS bddisasm)

# -- bdshemu --

add_library(
    bdshemu STATIC
    bdshemu/bdshemu.c
    # Add the headers so they will show up in IDEs.
    inc/bdshemu.h)

set_target_properties(
    bdshemu
    PROPERTIES POSITION_INDEPENDENT_CODE ON
               C_STANDARD 11
               VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH})

target_include_directories(bdshemu PRIVATE bddisasm/include)
target_include_directories(bddisasm PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/inc>
                                           $<INSTALL_INTERFACE:${BDDISASM_INSTALL_INCLUDE_DIR}>)

target_link_libraries(bdshemu PUBLIC bddisasm)

target_compile_options(bdshemu PRIVATE ${BDDISASM_COMMON_COMPILE_OPTIONS})

check_c_compiler_flag(-maes HAS_MAES)
if (HAS_MAES)
    target_compile_options(bdshemu PRIVATE -maes)
endif ()

set_target_properties(
    bdshemu
    PROPERTIES PUBLIC_HEADER "inc/bdshemu.h"
               VERSION ${CMAKE_PROJECT_VERSION}
               SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR})

add_library(bddisasm::bdshemu ALIAS bdshemu)

# If this is the master project (and if the user requested it) add disasmtool.
if ((${CMAKE_PROJECT_NAME} STREQUAL ${PROJECT_NAME}) AND BDD_INCLUDE_TOOL)
    if (WIN32)
        add_subdirectory(disasmtool)
    else ()
        add_subdirectory(disasmtool_lix)
    endif ()
endif ()

# If this is the master project (and if the user requested it) add isagenerator.
if ((${CMAKE_PROJECT_NAME} STREQUAL ${PROJECT_NAME}) AND BDD_INCLUDE_ISAGENERATOR)
    add_subdirectory(isagenerator)
endif ()

# If this is the master project (and if the user requested it) add the fuzzer.
if ((${CMAKE_PROJECT_NAME} STREQUAL ${PROJECT_NAME}) AND BDD_INCLUDE_FUZZERS)
    add_subdirectory(bdshemu_fuzz)
endif ()

# If this is the master project add install and package targets.
if (${CMAKE_PROJECT_NAME} STREQUAL ${PROJECT_NAME})
    set(BDDISASM_INSTALL_CMAKEDIR
        "${CMAKE_INSTALL_LIBDIR}/cmake/bddisasm"
        CACHE STRING "Path to bddisasm cmake files.")

    set(BDDISASM_INSTALL_PCDIR
        "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
        CACHE STRING "Path to bddisasm pkgconfig files.")

    set(CMAKE_SKIP_BUILD_RPATH TRUE)
    set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
    set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

    install(
        TARGETS bddisasm bdshemu
        EXPORT bddisasmTargets
        INCLUDES
        DESTINATION ${BDDISASM_INSTALL_INCLUDE_DIR}
        PUBLIC_HEADER DESTINATION ${BDDISASM_INSTALL_INCLUDE_DIR} COMPONENT bddisasm_Development
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT bddisasm_Runtime
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
                COMPONENT bddisasm_Runtime
                NAMELINK_COMPONENT bddisasm_Development
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT bddisasm_Development)
    
    if (BDD_INCLUDE_TOOL)
        install(
            TARGETS disasmtool
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT bddisasm_Runtime)
    endif ()

    install(
        EXPORT bddisasmTargets
        DESTINATION ${BDDISASM_INSTALL_CMAKEDIR}
        NAMESPACE bddisasm::
        FILE bddisasmTargets.cmake
        COMPONENT bddisasm_Development)

    include(CMakePackageConfigHelpers)

    write_basic_package_version_file(
        "bddisasmConfigVersion.cmake"
        VERSION ${CMAKE_PROJECT_VERSION}
        COMPATIBILITY SameMajorVersion)

    install(
        FILES bddisasmConfig.cmake ${CMAKE_CURRENT_BINARY_DIR}/bddisasmConfigVersion.cmake
        DESTINATION ${BDDISASM_INSTALL_CMAKEDIR}
        COMPONENT bddisasm_Development)

    configure_file("bddisasm.pc.in" "${CMAKE_STATIC_LIBRARY_PREFIX}bddisasm.pc" @ONLY)

    install(
        FILES "${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_STATIC_LIBRARY_PREFIX}bddisasm.pc"
        DESTINATION "${BDDISASM_INSTALL_PCDIR}"
        COMPONENT bddisasm_Development)

    set(CPACK_PACKAGE_VENDOR "Bitdefender")

    if (NOT CPACK_GENERATOR)
        if (NOT WIN32)
            set(CPACK_GENERATOR "DEB")
        else ()
            set(CPACK_GENERATOR "ZIP")
        endif ()
    endif ()

    set(CPACK_DEBIAN_PACKAGE_MAINTAINER "Bitdefender HVI Team <hvmi-oss@bitdefender.com>")
    set(CPACK_DEBIAN_PACKAGE_DEPENDS "")
    set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE "amd64")
    set(CPACK_DEBIAN_PACKAGE_SECTION "devel")

    include(CPack)
endif ()

=== Makefile ===
.PHONY: all bddisasm bdshemu

all: bddisasm bdshemu

bddisasm:
	@$(MAKE) --no-print-directory -C bddisasm
	@$(MAKE) --no-print-directory RELEASE=y -C bddisasm

bdshemu:
	@$(MAKE) --no-print-directory -C bdshemu
	@$(MAKE) --no-print-directory RELEASE=y -C bdshemu

clean:
	@$(MAKE) --no-print-directory -C bddisasm clean
	@$(MAKE) --no-print-directory RELEASE=y -C bddisasm clean
	@$(MAKE) --no-print-directory -C bdshemu clean
	@$(MAKE) --no-print-directory RELEASE=y -C bdshemu clean
    
install:
	@$(MAKE) --no-print-directory RELEASE=y -C bddisasm install
	@$(MAKE) --no-print-directory RELEASE=y -C bdshemu install

=== bddisasm/Makefile ===
.PHONY: clean

SRC_FILES := crt.c bddisasm.c bdformat.c bdhelpers.c

OBJECTS := $(SRC_FILES:.c=.o)

INCLUDES := -Iinclude -I../inc -I../../inc

ifeq ($(PLATFORM),)
	PLATFORM := x64
endif

ifeq ($(RELEASE),y)
	CONFIGURATION := Release
else
	CONFIGURATION := Debug
endif

ifeq ($(PREFIX),)
	PREFIX := /usr/local
endif

DEFINES := -D_LIB -DAMD64

INT_DIR := ../_intdir/bddisasm/$(PLATFORM)/$(CONFIGURATION)

DEP_DIR := $(INT_DIR)/.d

OUT_DIR := ../bin/$(PLATFORM)/$(CONFIGURATION)

OBJECTS_PATH := $(addprefix $(INT_DIR)/, $(OBJECTS))

LIB_NAME := libbddisasm.a

WARNINGS_ENABLE := -Wall -Wextra -Wshadow -Wstrict-overflow \
	-Wframe-larger-than=3072 -Wstack-usage=3072

WARNINGS_DISABLE := -Wno-missing-field-initializers \
	-Wno-missing-braces \
	-Wno-unused-function \
	-Wno-unused-variable \
	-Wno-unknown-pragmas \
	-Wno-format \
	-Wno-multichar

# Some warnings are compiler-specific, some version-specific
ifeq (,$(findstring clang,$(CC)))
	CC_VERSION_MAJOR = $(shell $(CC) -dumpversion | cut -d '.' -f1)
	CC_VERSION_GT_4 = $(shell [ $(CC_VERSION_MAJOR) -gt 4 ] && echo true)
	CC_VERSION_GT_5 = $(shell [ $(CC_VERSION_MAJOR) -gt 5 ] && echo true)

	ifeq (true,$(CC_VERSION_GT_4))
		WARNINGS_DISABLE += -Wno-incompatible-pointer-types
	endif

	ifeq (true,$(CC_VERSION_GT_5))
		WARNINGS_ENABLE += -Wshift-overflow=2 \
			-Wnull-dereference \
			-Wduplicated-cond
      endif
else
	WARNINGS_DISABLE += -Wno-typedef-redefinition \
		-Wno-missing-braces \
		-Wno-incompatible-pointer-types \
		-Wno-missing-field-initializers
endif

DEPFLAGS = -MT $@ -MMD -MP -MF $(DEP_DIR)/$*.Td

CFLAGS = -pipe -c -std=c11 -fpic -fno-strict-aliasing \
	-D_REENTRANT -fstack-protector -ffunction-sections -fdata-sections \
	$(WARNINGS_ENABLE) $(WARNINGS_DISABLE) $(DEFINES) $(INCLUDES)

ifeq ($(RELEASE),y)
	CFLAGS += -Ofast -g3 -DNDEBUG -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=1
else
	CFLAGS += -O0 -g3 -D_DEBUG -DDEBUG
endif

all: $(LIB_NAME)

# Here it will link the objects created below in the final .a
$(LIB_NAME): $(OBJECTS_PATH)
	@mkdir -p $(OUT_DIR)
	@ar rcs $(OUT_DIR)/$(LIB_NAME) $(OBJECTS_PATH)
	@echo Disasm library in $(OUT_DIR)/$(LIB_NAME)

# We need to mkdir inside the rule, so each subfolder gets created,
# and avoiding conflicts:
# ./linux/example.c => $(INT_DIR)/linux/example.o
# ./example.c => $(INT_DIR)/example.o
$(INT_DIR)/%.o: %.c $(DEP_DIR)/%.d
	@mkdir -p $(dir $@)
	@mkdir -p $(dir $(DEP_DIR)/$<) >/dev/null
	@echo $<
	@$(CC) $(DEPFLAGS) $(CFLAGS) -c $< -o $@
	@mv -f $(DEP_DIR)/$*.Td $(DEP_DIR)/$*.d

# So 'make' won't fail if the dependecy file doesn't exist
$(DEP_DIR)/%.d: ;

# Don't delete the dependecy files
.PRECIOUS: $(DEP_DIR)/%.d

# Include all the dependecy files (this will trigger a rebuild if a header is changed)
-include $(patsubst %,$(DEP_DIR)/%.d,$(basename $(SRC_FILES)))

clean_lib_file:
	@rm $(OUT_DIR)/$(LIB_NAME) 2>/dev/null ||:

clean_int_dir:
	@rm -r $(INT_DIR) 2>/dev/null ||:

clean_dep_dir:
	@rm -r $(DEP_DIR) 2>/dev/null ||:

clean: clean_lib_file clean_int_dir clean_dep_dir

install: all
	install -d $(DESTDIR)$(PREFIX)/lib/
	install -m 644 $(OUT_DIR)/$(LIB_NAME) $(DESTDIR)$(PREFIX)/lib/
	install -d $(DESTDIR)$(PREFIX)/include/bddisasm
	cp -r ../inc/* $(DESTDIR)$(PREFIX)/include/bddisasm/

=== bdshemu_fuzz/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

option(BDD_FUZZ_WITH_LOGS "Enable logging for the fuzzer" OFF)

project(bdshemu_fuzzer LANGUAGES C)

add_executable(shfuzzx86 bdshemu_fuzzer.c)
target_link_libraries(shfuzzx86 PRIVATE bddisasm::bdshemu)
target_compile_definitions(shfuzzx86 PRIVATE FUZZ_X86)

add_executable(shfuzzx64 bdshemu_fuzzer.c)
target_link_libraries(shfuzzx64 PRIVATE bddisasm::bdshemu)
target_compile_definitions(shfuzzx64 PRIVATE FUZZ_X64)

if (BDD_FUZZ_WITH_LOGS)
    target_compile_definitions(shfuzzx86 PRIVATE ENABLE_LOGGING)
    target_compile_definitions(shfuzzx64 PRIVATE ENABLE_LOGGING)
endif (BDD_FUZZ_WITH_LOGS)

add_custom_target(shfuzz DEPENDS shfuzzx86 shfuzzx64)

=== disasmtool/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(disasmtool LANGUAGES C)

# Use Release as the build type if no build type was specified and we're not using a multi-config generator    .
if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    message(STATUS "No build type given. Will use 'Release'")
    set(CMAKE_BUILD_TYPE
        "Release"
        CACHE STRING "Choose the type of build." FORCE)
    # Set the possible values of build type for cmake-gui.
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release")
endif ()

if (NOT TARGET bddisasm)
    find_package(bddisasm REQUIRED)
endif ()

add_executable(disasmtool disasmtool.c)
target_link_libraries(disasmtool PRIVATE bddisasm::bddisasm bddisasm::bdshemu)

if ("${CMAKE_BUILD_TYPE}" STREQUAL "Release")
    include(CheckIPOSupported)
    check_ipo_supported(RESULT USE_IPO)
    if (USE_IPO)
        set_target_properties(bddisasm PROPERTIES INTERPROCEDURAL_OPTIMIZATION True)
    endif ()
endif ()

if (MSVC OR "${CMAKE_C_COMPILER_FRONTEND_VARIANT}" STREQUAL "MSVC")
    target_compile_options(disasmtool PRIVATE /W4 /WX)

    if ("${CMAKE_C_COMPILER_ID}" STREQUAL "Clang")
        target_compile_options(disasmtool PRIVATE -Wno-format)
    endif ()
else ()
    target_compile_options(
        disasmtool
        PRIVATE -Wall
                -Wno-unknown-pragmas
                -Wextra
                -Wshadow
                -Wno-format
                -Wno-cast-function-type
                -Wstrict-overflow=2
                -Wstrict-prototypes
                -Wwrite-strings
                -Wshadow
                -Winit-self
                -Wno-unused-function
                -Wno-multichar
                -Wno-incompatible-pointer-types
                -Wno-discarded-qualifiers
                -Wnull-dereference
                -Wduplicated-cond
                -Werror=implicit-function-declaration
                -pipe
                -fwrapv
                -fno-strict-aliasing
                -fstack-protector-strong
                -fno-omit-frame-pointer
                -ffunction-sections
                -fdata-sections
                -g3
                -gdwarf-4
                -grecord-gcc-switches
                -march=westmere)
endif ()

=== disasmtool_lix/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(disasmtool LANGUAGES CXX)

# Use Release as the build type if no build type was specified and we're not using a multi-config generator    .
if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    message(STATUS "No build type given. Will use 'Release'")
    set(CMAKE_BUILD_TYPE
        "Release"
        CACHE STRING "Choose the type of build." FORCE)
    # Set the possible values of build type for cmake-gui.
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release")
endif ()

add_executable(disasmtool disasmtool.cpp dumpers.cpp rapidjson.cpp)

target_compile_options(
    disasmtool
    PRIVATE "$<$<CONFIG:Release>:-U_FORTIFY_SOURCE>"
            "$<$<CONFIG:Release>:-D_FORTIFY_SOURCE=2>"
            -Wall
            -Wextra
            -Wshadow
            -Wformat-security
            -Wstrict-overflow=2
            -Wno-unused-function
            -Wno-multichar
            -Werror=format-security
            -pipe
            -fpie
            -fwrapv
            -fno-strict-aliasing
            -fstack-protector-strong
            -ffunction-sections
            -fdata-sections
            -g3
            -gdwarf-4
            -grecord-gcc-switches
            -march=nehalem
            -fno-omit-frame-pointer)

if (NOT TARGET bddisasm)
    find_package(bddisasm REQUIRED)
endif ()

find_package(RapidJSON QUIET REQUIRED)

target_link_libraries(disasmtool PRIVATE bddisasm::bddisasm bddisasm::bdshemu)
# :( https://github.com/satishbabariya/modern-cmake#good-boys-export-their-targets
target_include_directories(disasmtool PRIVATE ${RapidJSON_INCLUDE_DIRS})

if ("${CMAKE_BUILD_TYPE}" STREQUAL "Release")
    include(CheckIPOSupported)
    check_ipo_supported(RESULT USE_IPO)
    if (USE_IPO)
        set_target_properties(disasmtool PROPERTIES INTERPROCEDURAL_OPTIMIZATION True)
    endif ()
endif ()

set_target_properties(
    disasmtool
    PROPERTIES POSITION_INDEPENDENT_CODE ON
               CXX_STANDARD 17
               CXX_STANDARD_REQUIRED ON
               CXX_EXTENSIONS ON)

=== disasmtool_lix/Makefile ===
.PHONY: all last_build debug release

CMAKE_BUILD_DIR = build

CPUCOUNT := $(shell grep -c "^processor" /proc/cpuinfo)

ifneq (,$(CPUCOUNT))
EXTRA_MAKE_ARGS := -j$(CPUCOUNT)
endif

# NINJA := $(shell which ninja 2>/dev/null)

ifneq (,$(NINJA))
GENERATOR := "Ninja"
else
GENERATOR := "Unix Makefiles"
endif

$(shell if [ ! -d $(CMAKE_BUILD_DIR) ]; then mkdir $(CMAKE_BUILD_DIR); fi)

all: last_build

last_build:
	@cmake -H. -G$(GENERATOR) -B$(CMAKE_BUILD_DIR) -DCMAKE_EXPORT_COMPILE_COMMANDS=ON
	@cmake --build $(CMAKE_BUILD_DIR) -- $(EXTRA_MAKE_ARGS)

debug: CMAKE_BUILD_TYPE := Debug
debug: build

release: CMAKE_BUILD_TYPE := Release
release: build

clean:
	@if [ -d $(CMAKE_BUILD_DIR) ]; then cmake --build $(CMAKE_BUILD_DIR) --target clean; fi

reset:
	@if [ -d $(CMAKE_BUILD_DIR) ]; then rm -r $(CMAKE_BUILD_DIR); fi

=== isagenerator/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(isagenerator)

include(FindPython3)

find_package(Python3 COMPONENTS Interpreter)
if (Python3_FOUND)
    add_custom_target(
        isagenerator
        COMMAND Python3::Interpreter generate_tables.py instructions
        WORKING_DIRECTORY "${CMAKE_CURRENT_LIST_DIR}"
        COMMENT "Generating instruction tables")
endif (Python3_FOUND)

=== isagenerator/Makefile ===
.PHONY: all

all:
	python3 generate_tables.py instructions

=== debian/changelog ===
bddisasm (1.37.0-0parrot1) parrot-updates; urgency=medium

  * Update changelog for 1.34.10-1parrot1 release
  * New upstream version 1.37.0

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Mon, 05 Jun 2023 20:40:54 +0700

bddisasm (1.34.10-1parrot1) parrot-updates; urgency=medium

  [ Nong Hoang Tu ]
  * Initial release

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Tue, 28 Feb 2023 20:53:26 +0700

=== debian/control ===
Source: bddisasm
Section: utils
Priority: optional
Maintainer: Parrot Team <team@parrotsec.org>
Uploaders: Nong Hoang Tu <dmknght@parrotsec.org>
Build-Depends: debhelper-compat (= 13), cmake, rapidjson-dev
Standards-Version: 4.5.1
Homepage: https://github.com/bitdefender/bddisasm/
#Vcs-Browser: https://salsa.debian.org/debian/bddisasm
#Vcs-Git: https://salsa.debian.org/debian/bddisasm.git
Rules-Requires-Root: no

Package: bddisasm
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: The BitDefender disassembler
 The Bitdefender disassembler (bddisasm) is a lightweight,
 x86/x64 only instruction decoder. It is easy to integrate,
 easy to work with, it has no external dependencies, it is
 thread-safe, it allocates no memory at all, it works in
 virtually any environment (we use it inside user, kernel,
 hypervisor, on both Windows and Linux environments),
 and it provides lots of info regarding the decoded instructions,
 such as: operands (both explicit and implicit), access mode
 for each operand, CPUID feature flag, flags access, etc.


Package: libbddisasm-dev
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Architecture: any
Description: The BitDefender disassembler devel files
 This package provides header files and static libs

=== debian/watch ===
version=4
https://github.com/bitdefender/bddisasm/tags/ .*/v(\d.+)\.tar\.gz
